/*
 * ********************************************************************************************************************
 *
 *               iFHS7.
 *              ;BBMBMBMc                  rZMBMBR              BMB
 *              MBEr:;PBM,               7MBMMEOBB:             BBB                       RBW
 *     XK:      BO     SB.     :SZ       MBM.       c;;     ir  BBM :FFr       :SSF:    ;xBMB:r   iuGXv.    i:. iF2;
 *     DBBM0r.  :D     S7   ;XMBMB       GMBMu.     MBM:   BMB  MBMBBBMBMS   WMBMBMBBK  MBMBMBM  BMBRBMBW  .MBMBMBMBB
 *      :JMRMMD  ..    ,  1MMRM1;         ;MBMBBR:   MBM  ;MB:  BMB:   MBM. RMBr   sBMH   BM0         UMB,  BMB.  KMBv
 *     ;.   XOW  B1; :uM: 1RE,   i           .2BMBs  rMB. MBO   MBO    JMB; MBB     MBM   BBS    7MBMBOBM:  MBW   :BMc
 *     OBRJ.SEE  MRDOWOR, 3DE:7OBM       .     ;BMB   RMR7BM    BMB    MBB. BMB    ,BMR  .BBZ   MMB   rMB,  BMM   rMB7
 *     :FBRO0D0  RKXSXPR. JOKOOMPi       BMBSSWBMB;    BMBB:    MBMB0ZMBMS  .BMBOXRBMB    MBMDE RBM2;SMBM;  MBB   xBM2
 *         iZGE  O0SHSPO. uGZ7.          sBMBMBDL      :BMO     OZu:BMBK,     rRBMB0;     ,EBMB  xBMBr:ER.  RDU   :OO;
 *     ,BZ, 1D0  RPSFHXR. xWZ .SMr                  . .BBB
 *      :0BMRDG  RESSSKR. 2WOMBW;                   BMBMR
 *         i0BM: SWKHKGO  MBDv
 *           .UB  OOGDM. MK,                                          Copyright (c) 2015-2019.  斯伯坦机器人
 *              ,  XMW  ..
 *                  r                                                                     All rights reserved.
 *
 * ********************************************************************************************************************
 */

package com.sybotan.android.demo.activities

import android.app.Activity
import android.graphics.BitmapFactory
import android.graphics.PointF
import android.support.v7.app.AppCompatActivity
import android.os.Bundle
import android.util.Log
import android.util.SizeF
import android.widget.Toast
import cn.sagacloud.android.cadengine.FloorScene
import cn.sagacloud.cadengine.HttpDownloadMap
import com.fasterxml.jackson.databind.PropertyNamingStrategy
import com.sybotan.android.demo.R
import com.sybotan.android.demo.R.id.graphyView
import com.sybotan.android.demo.entitiies.Revit
import com.sybotan.android.demo.graphy.GraphyWallItem
import com.sybotan.android.graphy.SGraphyScene
import com.sybotan.android.graphy.events.SGraphyViewMoveEvent
import com.sybotan.android.graphy.items.SGraphyClockItem
import com.sybotan.base.utils.SJsonUtil
import kotlinx.android.synthetic.main.activity_graphy.*
import org.greenrobot.eventbus.EventBus
import org.greenrobot.eventbus.Subscribe
import org.jetbrains.anko.doAsync
import org.jetbrains.anko.uiThread
import android.support.v4.app.ActivityCompat.startActivityForResult

import android.content.Intent
import android.view.View
import cn.sagacloud.android.cadengine.items.PointItem
import com.sybotan.android.demo.bean.result.SpaceJobModel
import com.sybotan.android.demo.viewmodel.GraphyVM
import com.zbar.lib.CaptureActivity


class GraphyActivity : BaseActivity() {
    companion object {
        private val TAG = GraphyActivity::class.java.name
        private val REQUEST_CODE_SCAN = 0x0000 // 扫描二维码
    }

    //实际距离
    val distance = 1800f

    //缩放后的同比例距离
    var realDistance = 0f

    val scene = FloorScene()

    //    val path = "base/cbde057b91e711eb9901557a780001bf.jsonz"
//    val path = "base/ebd53bb00d3511eb9a1db95f725712e8.jsonz"
//    val path = "base/a4e671ec8b8111eb9a520dc30d098a92.jsonz"
//    val path = "base/0764ad79555d11ebab557bd2e22cfb56.jsonz"
    val path = "base/05d5b9e6c8c411eb8437353008b31107.jsonz"

    @Subscribe
    fun test(msg: SGraphyViewMoveEvent) {
        Log.d(TAG, "msg=$msg")

    } // test()

    /**
     * 创建Activity时的回调函数
     *
     * @param   savedInstanceState
     */
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_graphy)
        // 注册eventbus
        EventBus.getDefault().register(this)

        graphyView.scene = scene

        /** 开启异步 */
        doAsync {
//            scene.loadUrl("http://adm.sagacloud.cn/image-service/common/file_get?systemId=revit&key=base/61a99fc1a66b11eb8f633d7605ae9def.jsonz")
//            scene.loadUrl("http://api.sagacloud.cn/dp-auxiliary/image-service/common/file_get?systemId=revit&key=Fl42010500018b580334dcf111e8a553db1eadfac99320190803114958bim.jsonz",false)
            val downloadGZIPMap =
                HttpDownloadMap.downloadGZIPMap(path)
            if (downloadGZIPMap != null) {
                scene.loadData(downloadGZIPMap!!)
            }
            /** 主线程处理ui */
            uiThread {
                /** 适应屏幕大小 */
                graphyView.fitSceneToView()
//                graphyView.defaultScale = graphyView.scale
                /** 限定移动范围不超出屏幕 */
//                graphyView.moveRange()
                graphyView.post {
                    Log.e("viewW", graphyView.width.toString())
                }

                Log.e("viewH", graphyView.measuredHeight.toString())
            }
        }
        nfc.setOnClickListener { Toast.makeText(this, "正在开发中，敬请期待", Toast.LENGTH_SHORT).show() }
        modelCheckBox.setOnCheckedChangeListener { buttonView, isChecked ->
            if (isChecked) {
                modelSubmit.isEnabled = true
                modelSubmit.alpha = 1f
            } else {
                modelSubmit.isEnabled = false
                modelSubmit.alpha = 0.3f
            }
        }

        addDot.setOnClickListener {
            scene.type = "dot"
            addDot.alpha = 0.3f
        }

        qrcode.setOnClickListener {
            val intent = Intent(this@GraphyActivity, CaptureActivity::class.java)
            startActivityForResult(intent, REQUEST_CODE_SCAN)
        }

        scene.setOnSingleTopUp(object : FloorScene.OnSingleTopUp {
            override fun onSingUp(x: Float, y: Float) {
                if ("dot".equals(scene.type)) {
                    scene.type = "normal"
                    addDot.alpha = 1f
                    return
                }

                if ("normal".equals(scene.type)) {
                    realDistance = distance * scene.defaultPointScale / graphyView.scale
                    for (point in scene.pointItemList) {
                        val sqrt = Math.sqrt(
                            Math.pow(
                                Math.abs(x - point.data.mX).toDouble(),
                                2.0
                            ) + Math.pow(Math.abs(y - point.data.mY).toDouble(), 2.0)
                        ).toInt()
                        if (sqrt < realDistance) {
                            Toast.makeText(this@GraphyActivity, "x=" + x, Toast.LENGTH_LONG).show()
                            showDotDetail(point)
                            break
                        }
                    }
                    return
                }
            }
        })
        initViewModel()


        return
    } // Function onCreate()

    private fun initViewModel() {
        var graphyVM = GraphyVM({ name, params ->
            when (name) {
                GraphyVM.SPACE_JOB -> {
                    val list = params as (List<SpaceJobModel>)
                }
            }
        }, this)
        graphyVM.getSpaceJob()
    }

    private fun showDotDetail(point: PointItem) {
        spaceStructure.visibility = View.GONE
        quesDetail.visibility = View.VISIBLE
        quesTv.setText(
            "这是描述问题的文本，左侧是拍照图片。" +
                    "\nx轴:${point.data.mX}" +
                    "\ny轴:${point.data.mY}" +
                    "\n点击下方“问题已解决”按钮后可关闭该问题点。"
        )
        quesSubmit.setOnClickListener {
            spaceStructure.visibility = View.VISIBLE
            quesDetail.visibility = View.GONE
            scene.removeItem(point)
            scene.pointItemList.remove(point)
        }
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        when (requestCode) {
            REQUEST_CODE_SCAN ->                 // 扫描二维码回传
                if (resultCode == RESULT_OK) {
                    if (data != null) {
                        //获取扫描结果
                        val bundle = data.extras
                        val result = bundle.getString(CaptureActivity.EXTRA_STRING)
                        Log.e("tag", "扫描结果：$result")
                    }
                }
            else -> {
            }
        }
    }


} // Class GraphyActivity
